
!GRPharoPlatform methodsFor: '*seaside-pharo-flow' stamp: 'jf 2/9/2010 01:36'!
seasideCallbackMarker
	| context |
	context := thisContext sender.
	[ context isNil or: [ (context receiver isKindOf: WACallback) or: [ context method == (WATaskVisitor >> #visitTask:) ] ] ]
		whileFalse: [ context := context sender ].
	context isNil
		ifTrue: [ self error: 'You can only #call: and #answer: from within a callback or a Task.' ].
	^ context! !

!GRPharoPlatform methodsFor: '*seaside-pharo-flow' stamp: 'jf 2/9/2010 01:36'!
seasideSuspendFlowDo: aBlock
	| continuation |
	continuation := WAPartialContinuation
		from: thisContext sender
		to: self seasideCallbackMarker.
	^ aBlock value: [ :answer |
		[ continuation value: answer ]
			on: WAMarkerRequest
			do: [ :request | request resume: self seasideCallbackMarker ] ]! !

!GRPackage class methodsFor: '*seaside-pharo-flow' stamp: 'lr 2/17/2010 15:13'!
seasidePharoFlow
	^ self new
		name: 'Seaside-Pharo-Flow';
		addDependency: 'Seaside-Flow';
		addDependency: 'Grease-Pharo-Core';
		addDependency: 'Seaside-Pharo-Continuation';
		url: #seasideUrl;
		yourself! !
